Summary: Disk Pool Manager
Name: DPM
Version: 1.6.5
Release: 5sec.slc4
Source0: %{name}-%{version}.src.tar.gz
AutoReqProv: no
Group: grid/lcg
BuildRoot: %{_builddir}/%{name}-%{version}-root
License: GPL
Prefix: /opt/lcg

%define __spec_install_post %{nil}
%define debug_package %{nil}
%define _unpackaged_files_terminate_build  %{nil}

%description
Light weight Disk Pool Manager offering SRMv1, SRMv2 and socket interfaces.

%package server-oracle
Summary: DPM Oracle Server
Group: grid/lcg
Requires: lcg-dm-common >= 1.6.1
AutoReqProv: no
%description server-oracle
DPM server with Oracle database backend

%package name-server-oracle
Summary: DPNS Oracle Server
Group: grid/lcg
Requires: lcg-dm-common >= 1.6.1
AutoReqProv: no
%description name-server-oracle
DPNS server with Oracle database backend

%package srm-server-oracle
Summary: SRM Oracle Servers
Group: grid/lcg
Requires: lcg-dm-common >= 1.6.1, DPM-client >= 1.6.5, CGSI_gSOAP_2.6 >= 1.1.15-6, CGSI_gSOAP_2.6-voms >= 1.1.15-6
AutoReqProv: no
%description srm-server-oracle
SRM servers with Oracle database backend

%prep
%setup -q

%build
./configure
make

# create the DPMCONFIG template
echo "<username>/<password>@<oracle_sid>" > DPMCONFIG
# create the NSCONFIG template
echo "<username>/<password>@<oracle_sid>" > NSCONFIG

%install 
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/var/log/dpns
mkdir -p ${RPM_BUILD_ROOT}/var/log/dpm
mkdir -p ${RPM_BUILD_ROOT}/etc/logrotate.d
mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
mkdir -p ${RPM_BUILD_ROOT}/etc/sysconfig
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/etc
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/multiple-domains
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/DPM-migration
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/DPM-migration/virtualIds
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/change-dpm-name
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/dpm-support-srmv2.2

make prefix=${RPM_BUILD_ROOT}%{prefix} install
make prefix=${RPM_BUILD_ROOT}%{prefix} install.man

# For the DPM
cp DPMCONFIG ${RPM_BUILD_ROOT}%{prefix}/etc/DPMCONFIG.templ
cp dpm/dpm_oracle_tbl.sql ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/create_dpm_tables_oracle.sql
cp -p dpm/dpm.logrotate ${RPM_BUILD_ROOT}/etc/logrotate.d/dpm
cp -p dpm/dpm.scripts.oracle ${RPM_BUILD_ROOT}/etc/init.d/dpm
cp -p dpm/dpm.sysconfig.oracle ${RPM_BUILD_ROOT}/etc/sysconfig/dpm.templ
cp -p scripts/DPM-migration/migrate-oracle-schema-to-2-1-0.sql ${RPM_BUILD_ROOT}%{prefix}/share/%{name}

# For the DPNS
cp NSCONFIG ${RPM_BUILD_ROOT}%{prefix}/etc/NSCONFIG.templ
cp -p ns/Cns_oracle_tbl.sql ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/create_dpns_tables_oracle.sql
cp -p scripts/multiple-domains/README ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/multiple-domains/README
cp -p scripts/multiple-domains/updateDomainName ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/multiple-domains/updateDomainName
cp -p scripts/multiple-domains/UpdateDpmDatabase.pm ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/multiple-domains/UpdateDpmDatabase.pm
cp -p scripts/multiple-domains/Common.pm ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/multiple-domains/Common.pm
cp -p scripts/DPM-migration/virtualIds/README ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/DPM-migration/virtualIds/README
cp -p scripts/DPM-migration/virtualIds/create-uid-gid-mappings.sh ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/DPM-migration/virtualIds/create-uid-gid-mappings.sh
cp -p scripts/DPM-migration/virtualIds/migrate-oracle-schema-to-2-2-0.sql ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/DPM-migration/virtualIds/migrate-oracle-schema-to-2-2-0.sql
cp -p scripts/change-dpm-name/changeDpmName ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/change-dpm-name/changeDpmName
cp -p scripts/change-dpm-name/Common.pm ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/change-dpm-name/Common.pm
cp -p scripts/change-dpm-name/UpdateDpmDatabase.pm ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/change-dpm-name/UpdateDpmDatabase.pm
cp -p scripts/change-dpm-name/README ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/change-dpm-name/README
cp -p scripts/dpm-support-srmv2.2/Common.pm ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/dpm-support-srmv2.2/Common.pm
cp -p scripts/dpm-support-srmv2.2/README ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/dpm-support-srmv2.2/README
cp -p scripts/dpm-support-srmv2.2/UpdateDpmDatabase.pm ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/dpm-support-srmv2.2/UpdateDpmDatabase.pm
cp -p scripts/dpm-support-srmv2.2/dpm_support_srmv2.2 ${RPM_BUILD_ROOT}%{prefix}/share/%{name}/dpm-support-srmv2.2/dpm_support_srmv2.2
cp -p ns/dpnsdaemon.logrotate ${RPM_BUILD_ROOT}/etc/logrotate.d/dpnsdaemon
cp -p ns/dpnsdaemon.scripts.oracle ${RPM_BUILD_ROOT}/etc/init.d/dpnsdaemon
cp -p ns/dpnsdaemon.sysconfig.oracle ${RPM_BUILD_ROOT}/etc/sysconfig/dpnsdaemon.templ

# For the SRM server
cp -p srmv1/srmv1.logrotate ${RPM_BUILD_ROOT}/etc/logrotate.d/srmv1
cp -p srmv1/srmv1.scripts.oracle ${RPM_BUILD_ROOT}/etc/init.d/srmv1
cp -p srmv1/srmv1.sysconfig.oracle ${RPM_BUILD_ROOT}/etc/sysconfig/srmv1.templ
cp -p srmv2/srmv2.logrotate ${RPM_BUILD_ROOT}/etc/logrotate.d/srmv2
cp -p srmv2/srmv2.scripts.oracle ${RPM_BUILD_ROOT}/etc/init.d/srmv2
cp -p srmv2/srmv2.sysconfig.oracle ${RPM_BUILD_ROOT}/etc/sysconfig/srmv2.templ
cp -p srmv2.2/srmv2.2.logrotate ${RPM_BUILD_ROOT}/etc/logrotate.d/srmv2.2
cp -p srmv2.2/srmv2.2.scripts.oracle ${RPM_BUILD_ROOT}/etc/init.d/srmv2.2
cp -p srmv2.2/srmv2.2.sysconfig.oracle ${RPM_BUILD_ROOT}/etc/sysconfig/srmv2.2.templ

%clean
rm -rf ${RPM_BUILD_ROOT}

%files server-oracle
%defattr(-,root,root)
/var/log/dpm
%attr(755, root, root) %{prefix}/bin/dpm
%attr(755, root, root) %{prefix}/bin/dpm-shutdown
%attr(600, root, root) %{prefix}/etc/DPMCONFIG.templ
%{prefix}/share/DPM/create_dpm_tables_oracle.sql
%{prefix}/share/DPM/migrate-oracle-schema-to-2-1-0.sql
%{prefix}/man/man1/dpm.1
%{prefix}/man/man1/dpm-shutdown.1
%attr(644, root, root) /etc/logrotate.d/dpm
%attr(755, root, root) /etc/init.d/dpm
%attr(644, root, root) /etc/sysconfig/dpm.templ

%files name-server-oracle
%defattr(-,root,root)
/var/log/dpns
%attr(755, root, root) %{prefix}/bin/dpnsdaemon
%attr(755, root, root) %{prefix}/bin/dpns-shutdown
%attr(600, root, root) %{prefix}/etc/NSCONFIG.templ
%{prefix}/share/DPM/create_dpns_tables_oracle.sql
%{prefix}/share/DPM/multiple-domains/README
%{prefix}/share/DPM/multiple-domains/updateDomainName
%{prefix}/share/DPM/multiple-domains/UpdateDpmDatabase.pm
%{prefix}/share/DPM/multiple-domains/Common.pm
%{prefix}/share/DPM/DPM-migration/virtualIds/README
%{prefix}/share/DPM/DPM-migration/virtualIds/create-uid-gid-mappings.sh
%{prefix}/share/DPM/DPM-migration/virtualIds/migrate-oracle-schema-to-2-2-0.sql
%{prefix}/share/DPM/change-dpm-name/changeDpmName
%{prefix}/share/DPM/change-dpm-name/Common.pm
%{prefix}/share/DPM/change-dpm-name/UpdateDpmDatabase.pm
%{prefix}/share/DPM/change-dpm-name/README
%{prefix}/share/DPM/dpm-support-srmv2.2/Common.pm
%{prefix}/share/DPM/dpm-support-srmv2.2/README
%{prefix}/share/DPM/dpm-support-srmv2.2/UpdateDpmDatabase.pm
%attr(755, root, root) %{prefix}/share/DPM/dpm-support-srmv2.2/dpm_support_srmv2.2
%{prefix}/man/man1/dpnsdaemon.1
%{prefix}/man/man1/dpns-shutdown.1
%attr(644, root, root) /etc/logrotate.d/dpnsdaemon
%attr(755, root, root) /etc/init.d/dpnsdaemon
%attr(644, root, root) /etc/sysconfig/dpnsdaemon.templ

%files srm-server-oracle
%defattr(-,root,root)
%attr(755, root, root) %{prefix}/bin/srmv1
%attr(755, root, root) %{prefix}/bin/srmv2
%attr(755, root, root) %{prefix}/bin/srmv2.2
%{prefix}/man/man1/srmv1.1
%{prefix}/man/man1/srmv2.1
%{prefix}/man/man1/srmv2.2.1
%attr(644, root, root) /etc/logrotate.d/srmv1
%attr(755, root, root) /etc/init.d/srmv1
%attr(644, root, root) /etc/sysconfig/srmv1.templ
%attr(644, root, root) /etc/logrotate.d/srmv2
%attr(755, root, root) /etc/init.d/srmv2
%attr(644, root, root) /etc/sysconfig/srmv2.templ
%attr(644, root, root) /etc/logrotate.d/srmv2.2
%attr(755, root, root) /etc/init.d/srmv2.2
%attr(644, root, root) /etc/sysconfig/srmv2.2.templ

%post server-oracle
/sbin/chkconfig --add dpm

echo "The DPM is now installed."
echo "Please use the <install_dir>/etc/DPMCONFIG.templ template to create your own configuration file with the appropriate values."
echo " "
echo "Before running the DPM daemon, use /etc/sysconfig/dpm.templ to create the /etc/sysconfig/dpm file and modify it if necessary."
echo " "
echo "Then, to start/stop the DPM server, use the following command :"
echo " > service dpm start|stop"
echo " "
echo " "
echo "###################################################################"
echo "#                                                                 #"
echo "#                       VERY IMPORTANT                            #"
echo "#                                                                 #"
echo "# If upgrading from DPM version < 1.6.0 to version >= 1.6.0,      #"
echo "# you must run a migration script.                                #"
echo "#                                                                 #"
echo "# Please check :                                                  #"
echo "# https://uimon.cern.ch/twiki/bin/view/LCG/DpmSrmv2Support        #"
echo "#                                                                 #"
echo "###################################################################"
echo " "


%post name-server-oracle
/sbin/chkconfig --add dpnsdaemon

echo "The DPM Name Server is now installed."
echo "Please use the <install_dir>/etc/NSCONFIG.templ template to create your own configuration file with the appropriate values."
echo " "
echo "Before running the DPM Name Server daemon, use /etc/sysconfig/dpnsdaemon.templ to create the /etc/sysconfig/dpnsdaemon file and modify it if necessary."
echo " "
echo "Then, to start/stop the DPM Name Server, use the following command :"
echo " > service dpnsdaemon start|stop"
echo " "

%post srm-server-oracle
/sbin/chkconfig --add srmv1
/sbin/chkconfig --add srmv2

echo "The SRM servers are now installed."
echo "Please use the <install_dir>/etc/DPMCONFIG.templ template to create your own configuration file with the appropriate values."
echo " "
echo "Before running the SRM servers, use /etc/sysconfig/srmv1.templ and /etc/sysconfig/srmv2.templ to create the /etc/sysconfig/srmv1 and /etc/sysconfig/srmv2 files and modify them if necessary."
echo " "
echo "To start/stop the SRM servers, use the following commands :"
echo " > service srmv1 start|stop"
echo " > service srmv2 start|stop"
echo " "
